/*
	bmtape2
	BASIC MASTER Jr.̃t@Cǂݏ
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "bmtape2.h"

#define FALSE	0
#define TRUE	1

/*
	t@C`FbN (raw2s_300, raw2s_1200̉)
*/
static int chkFilename(const unsigned char *file)
{
	const unsigned char *p;

	for(p = file; p < file + 8; p++)
		if(*p < 0x20)
			return FALSE;
	return TRUE;
}

/*
	t@C𓾂 (raw2s_300, raw2s_1200̉)
*/
static char *getFilename(char *out, const unsigned char *in)
{
	const unsigned char *p;
	char *q = out;

	for(p = in; p < in + 8; p++)
		if(*p != ' ') {
			if(
			*p < 0x20 ||
			*p == '\\' ||
			*p == '/' ||
			*p == ':' ||
			*p == '*' ||
			*p == '?' ||
			*p == '"' ||
			*p == '<' ||
			*p == '>' ||
			*p == '|'
			)
				*q++ = '_';
			else
				*q++ = (char )*p;
		}
	*q = 0;
	return out;
}

/*
	sR[hϊ (raw2s_300̉)
*/
static char *decodeReturn(char *buf, int size)
{
	char *p;

	for(p = buf; p < buf + size; p++)
		if(*p == 0x0d)
			*p = '\n';
	return buf;
}

/*
	300baud̃x^C[Wt@C𓾂 (raw2s̉)
*/
static int raw2s_300(const unsigned char *raw, int raw_size)
{
	int i, kind, asc_block, bin_block, bsize, hsum, dsum, address, result;
	const unsigned char *p = raw;
	unsigned char file[8 + 1], prev_file[8 + 1] = "", data[256];
	char path[PATH_MAX];

	while(p < raw + raw_size) {
		/* 擪0xff */
		if(*p == 0xff)
			while(*++p == 0xff)
				;

		/* Jn? */
		if(*p++ != 0x01)
			continue;
		
		/* ŏIubN? */
		hsum = -*p;
		kind = *p++;

		/* ASCIĨubNԍ𓾂 */
		hsum -= *p;
		asc_block = *p++;

		/* t@C𓾂 */
		hsum -= *p;
		file[0] = *p++;
		hsum -= *p;
		file[1] = *p++;
		hsum -= *p;
		file[2] = *p++;
		hsum -= *p;
		file[3] = *p++;
		hsum -= *p;
		file[4] = *p++;
		hsum -= *p;
		file[5] = *p++;
		hsum -= *p;
		file[6] = *p++;
		hsum -= *p;
		file[7] = *p++;
		file[8] = 0;

		/* oCĩubNԍ𓾂 */
		hsum -= *p;
		bin_block = *p++;

		/* TCY𓾂 */
		hsum -= *p;
		bsize = *p++;
		if(bsize == 0)
			bsize = 0x100;
	
		/* AhX𓾂 */
		hsum -= *p;
		address = (int )*p++ << 8;
		hsum -= *p;
		address = address | (int )*p++;

		/* wb_̃T𓾂 */
		if(*p != (hsum & 0xff))
			fprintf(stderr, "HEADER SUM ERROR AT %s.%d %04x-%04x (H:%02x A:%02x)\n", file, bin_block, address, address + bsize - 1, *p, (hsum & 0xff));
		p++;
	
		/* f[^𓾂 */
		dsum = 0;
		for(i = 0; i < bsize; i++) {
			dsum -= *p;
			data[i] = *p++;
		}

		/* f[^̃T𓾂 */
		if(*p != (dsum & 0xff))
			fprintf(stderr, "DATA SUM ERROR AT %s.%d %04x-%04x (H:%02x A:%02x)\n", file, bin_block, address, address + bsize - 1, *p, (dsum & 0xff));
		p++;

		/* I */
		p++;

		switch(kind) {
		case 0x00:
			break;
		case 0x01:
		case 0x10:
			if(!chkFilename(file))
				continue;
			getFilename(path, file);
			if(kind == 0x01) {
				if(strcmp(file, prev_file) != 0)
					result = writeSRecordAbs(path, data, address, bsize);
				else
					result = appendSRecordAbs(path, data, address, bsize);
				if(result < 0) {
					fprintf(stderr, "Cannot write %s\n", path);
					return -1;
				}
				fprintf(stderr, "%s.%d\t%04x %d\n", file, bin_block, address, bsize);
			} else if(kind == 0x10 && bsize >= 2 && memcmp(data, "\xff\xff", 2) != 0) {
				decodeReturn(data, bsize);
				if(strcmp(file, prev_file) != 0)
					writeText(path, data, bsize);
				else
					appendText(path, data, bsize);
				fprintf(stderr, "%s.%d\t%04x %d\n", file, asc_block, address, bsize);
			}
			strcpy(prev_file, file);
			break;
		}
	}

	return (int )(p - raw);
}

/*
	1200baud̃x^C[Wt@C𓾂 (raw2s̉)
*/
static int raw2s_1200(const unsigned char *raw, int raw_size)
{
	int begin1, end1, size1, begin2, end2, size2;
	unsigned char file[8 + 1];
	const unsigned char *p = raw;
	char path[PATH_MAX];
	unsigned char buf[16] = {
		0x50, 0x0b,
		0x00, 0x00,
		0x00, 0x00,
		0x00, 0x00,
		0x00, 0x00,
		0xaf, 0xff,
		0x00, 0x00,
		0x04, 0x55
	};

	while(p < raw + raw_size) {
		/* 擪0x55 */
		if(*p == 0x55)
			while(*++p == 0x55)
				;
		
		/* Jn? */
		if(*p++ != 0xaa)
			continue;
	
		/* f[^ 擪AhX */
		begin1 = (int )(*p++) << 8;
		begin1 = begin1 | (int )(*p++);

		/* f[^ IAhX */
		end1 = (int )(*p++) << 8;
		end1 = end1 | (int )(*p++);
		size1 = end1 - begin1 + 1;

		/* ϐ 擪AhX */
		begin2 = (int )(*p++) << 8;
		begin2 = begin2 | (int )(*p++);
		if(begin2 != 0)
			begin2++;

		/* ϐ IAhX */
		end2 = (int )(*p++) << 8;
		end2 = end2 | (int )(*p++);
		if(end2 != 0)
			size2 = end2 - begin2 + 1;
		else
			size2 = 0;

		/* t@C */
		file[0] = *p++;
		file[1] = *p++;
		file[2] = *p++;
		file[3] = *p++;
		file[4] = *p++;
		file[5] = *p++;
		file[6] = *p++;
		file[7] = *p++;
		file[8] = 0;
		if(!chkFilename(file))
			continue;
		fprintf(stderr, "%s\t%04x %d %04x %d\n", file, begin1, size1, begin2, size2);
		fflush(stderr);
		getFilename(path, file);

		if(size1 < 0 || size2 < 0)
			continue;

		/* ϐ */
		unlink(path);
		if(0 < size2 && size2 <= raw_size - (int )(p - raw) - size1)
			appendSRecordAbs(path, p + size1, begin2, size2);

		/* f[^ */
		if(0 < size1 && size1 <= raw_size - (int )(p - raw))
			appendSRecordAbs(path, p, begin1, size1);

		/* AhX */
		if(size2 > 0) {
			buf[2] = begin2 >> 8;
			buf[3] = begin2 & 0xff;
			buf[4] = begin1 >> 8;
			buf[5] = begin1 & 0xff;
			buf[6] = end2 >> 8;
			buf[7] = end2 & 0xff;
			buf[8] = buf[12] = (end1 - 1) >> 8;
			buf[9] = buf[13] = (end1 - 1) & 0xff;
			appendSRecordAbs(path, buf, 0x0070, 0x10);
		}

		p += size1 + size2;
	}

	return (int )(p - raw);
}

/*
	x^C[Wt@C𓾂
*/
int raw2s(int baud, const unsigned char *raw, int raw_size)
{
	if(baud == 300)
		return raw2s_300(raw, raw_size);
	else if(baud == 1200)
		return raw2s_1200(raw, raw_size);
	else
		return -1;
}

/*
	1ubNoCi300baud̃x^C[Wɕϊ ()
*/
static int bin2raw_300_block(unsigned char *raw, const char *file, int kind, int asc_block, int bin_block, int address, const unsigned char *bin, int bin_size)
{
	int i, bsize, hsum, dsum = 0;
	unsigned char *p = raw;

	if(bin_size < 0)
		bsize = 0;
	else if(bin_size >= 0x100)
		bsize = 0x100;
	else
		bsize = bin_size;

	/* 擪0xff */
	for(i = 0; i < 65; i++)
		*p++ = 0xff;

	/* Jn */
	*p++ = 0x01;

	/* ubN̎ */
	if(bin_size <= 0)
		*p = 0x00;
	else
		*p = kind;
	hsum = -*p++;

	/* ASCIĨubNԍ */
	*p = asc_block;
	hsum -= *p++;

	/* t@C */
	*p = file[0];
	hsum -= *p++;
	*p = file[1];
	hsum -= *p++;
	*p = file[2];
	hsum -= *p++;
	*p = file[3];
	hsum -= *p++;
	*p = file[4];
	hsum -= *p++;
	*p = file[5];
	hsum -= *p++;
	*p = file[6];
	hsum -= *p++;
	*p = file[7];
	hsum -= *p++;

	/* oCĩubNԍ */
	*p = bin_block;
	hsum -= *p++;

	/* ubÑTCY */
	*p = bsize & 0xff;
	hsum -= *p++;

	/* AhX */
	*p = address >> 8;
	hsum -= *p++;
	*p = address & 0xff;
	hsum -= *p++;

	/* wb_̃T */
	*p++ = hsum & 0xff;

	/* f[^ */
	for(i = 0; i < bsize; i++) {
		*p = *bin++;
		dsum -= *p++;
	}

	/* f[^̃T */
	*p++ = dsum & 0xff;

	return (int )(p - raw);
}

/*
	1ubNoCi300baud̃x^C[Wɕϊ, ̃ubNֈړ ()
*/
static int bin2raw_300_block_next(unsigned char **raw, const char *file, int kind, int *asc_block, int *bin_block, int *address, const unsigned char **bin, int *bin_size)
{
	*raw += bin2raw_300_block(*raw, file, kind, *asc_block, *bin_block, *address, *bin, *bin_size);
	if(*bin_size <= 0)
		return FALSE;
	if(*bin_size <= 0x100)
		*bin_size = 0;
	else {
		*bin += 0x100;
		*bin_size -= 0x100;
		*address += 0x100;
		if(kind == 0x01)
			(*bin_block)++;
		else if(kind == 0x10)
			(*asc_block)++;
	}
	return TRUE;
}

/*
	oCi300baud̃x^C[Wɕϊ (bin2raw̉)
*/
static int bin2raw_300(unsigned char *raw, const char *file, int address, const unsigned char *bin, int bin_size)
{
	int asc_block = 1, bin_block = 1;
	unsigned char *p = raw;

	while(bin2raw_300_block_next(&p, file, 0x01, &asc_block, &bin_block, &address, &bin, &bin_size))
		;
	return (int )(p - raw);
}

/*
	oCi1200baud̃x^C[Wɕϊ (bin2raw̉)
*/
static int bin2raw_1200(unsigned char *raw, const char *file, int begin1, int end1, const unsigned char *bin1, int begin2, int end2, const unsigned char *bin2)
{
	int i;
	unsigned char *p = raw;

	/* 擪0x55 */
	for(i = 0; i < 255; i++)
		*p++ = 0x55;

	/* Jn */
	*p++ = 0xaa;

	/* f[^ JnAhX */
	*p++ = begin1 >> 8;
	*p++ = begin1 & 0xff;

	/* f[^ IAhX */
	*p++ = end1 >> 8;
	*p++ = end1 & 0xff;

	if(bin2 != NULL) {
		/* ϐ 擪AhX */
		*p++ = (begin2 - 1) >> 8;
		*p++ = (begin2 - 1) & 0xff;

		/* ϐ IAhX */
		*p++ = end2 >> 8;
		*p++ = end2 & 0xff;
	} else {
		/* ϐ 擪AhX */
		*p++ = 0;
		*p++ = 0;

		/* ϐ IAhX */
		*p++ = 0;
		*p++ = 0;
	}

	/* t@C */
	*p++ = file[0];
	*p++ = file[1];
	*p++ = file[2];
	*p++ = file[3];
	*p++ = file[4];
	*p++ = file[5];
	*p++ = file[6];
	*p++ = file[7];

	/* f[^ */
	for(i = begin1; i <= end1; i++)
		*p++ = *bin1++;

	/* ϐ */
	if(bin2 != NULL)
		for(i = begin2; i <= end2; i++)
			*p++ = *bin2++;

	/* I[? */
	*p++ = 0xf0;

	return (int )(p - raw);
}

/*
	oCi1200baud̃x^C[Wɕϊ
*/
int bin2raw(unsigned char *raw, int baud, const char *file, int address, const unsigned char *bin, int bin_size)
{
	if(baud == 300)
		return bin2raw_300(raw, file, address, bin, bin_size);
	else if(baud == 1200)
		return bin2raw_1200(raw, file, address, address + bin_size - 1, bin, 0, 0, NULL);
	else
		return -1;
}

/*
	Ԍ300baud̃x^C[Wɕϊ (bas2raw̉)
*/
static int bas2raw_300(unsigned char *raw, const char *file, const unsigned char *bin0, int begin1, int end1, const unsigned char *bin1, int begin2, int end2, const unsigned char *bin2)
{
	int address, size, block = 1;
	unsigned char *p = raw;

	/* ϐ */
	for(address = begin2, size = end2 - begin2 + 1; address <= end2; address += 0x100, bin2 += 0x100)
		p += bin2raw_300_block(p, file, 0x01, 0x39, block++, address, bin2, size);

	/* f[^ */
	for(address = begin1, size = end1 - begin1 + 1; address <= end1; address += 0x100, bin1 += 0x100)
		p += bin2raw_300_block(p, file, 0x01, 0x39, block++, address, bin1, size);

	/* AhX */
	p += bin2raw_300_block(p, file, 0x01, 0x39, 1, 0x0070, bin0, 0x10);

	/* I */
	p += bin2raw_300_block(p, file, 0x00, 0x39, 1, 0x0070, bin0, 1);
	return (int )(p - raw);
}

/*
	Ԍx^C[Wɕϊ
*/
int bas2raw(unsigned char *raw, int baud, const char *file, const unsigned char *bin)
{
	int begin1 = (((int )bin[0x74] << 8) | bin[0x75]);
	int end1   = (((int )bin[0x78] << 8) | bin[0x79]) + 1;
	int begin2 = (((int )bin[0x72] << 8) | bin[0x73]);
	int end2   = (((int )bin[0x76] << 8) | bin[0x77]);

	if(baud == 300)
		return bas2raw_300(raw, file, bin + 0x70, begin1, end1, bin + begin1, begin2, end2, bin + begin2);
	else if(baud == 1200)
		return bin2raw_1200(raw, file, begin1, end1, bin + begin1, begin2, end2, bin + begin2);
	else
		return -1;
}

/*
	1s̒𓾂(s܂) (text2bin̉)
*/
static int textlen(const char *buf)
{
	const char *p;

	for(p = buf; *p != '\n' && *p != '\r' && *p != 0; p++)
		;
	return (int )(p - buf) + 1;
}

/*
	eLXg1ubN, sϊ (test2raw_300, text2wav_300̉)
*/
static int text2bin(unsigned char *bin, const char **text, int *text_size)
{
	int bin_size = 0, len;

	while(*text_size > 0 && bin_size + textlen(*text) < 0x100) {
		len = textlen(*text);
		memcpy(bin, *text, len); bin[len - 1] = 0x0d;

		bin += len;
		bin_size += len;

		*text += len;
		*text_size -= len;
		if(len >= 1 && memcmp(*text - 1, "\r\n", 2) == 0) {
			(*text)++;
			(*text_size)--;
		}
	}
	return bin_size;
}

/*
	eLXg300baud̃x^C[Wɕϊ (text2raw̉)
*/
static int text2raw_300(unsigned char *raw, const char *file, const char *text, int text_size)
{
	int asc_block = 1, bin_size;
	unsigned char bin[0x100], *p = raw;

	while(text_size > 0) {
		bin_size = text2bin(bin, &text, &text_size);
		p += bin2raw_300_block(p, file, 0x10, asc_block, 1, 0x600, bin, bin_size);
		p += bin2raw_300_block(p, file, 0x00, asc_block, 1, 0x600, bin, 1);
		asc_block++;
	}

	bin[1] = bin[0] = 0xff;
	p += bin2raw_300_block(p, file, 0x10, asc_block, 1, 0x600, bin, 2);
	p += bin2raw_300_block(p, file, 0x00, asc_block, 1, 0x600, bin, 1);

	return (int )(p - raw);
}

/*
	eLXg1200baudx^C[Wɕϊ (text2raw̉)
*/
static int text2raw_1200(unsigned char *raw, const char *file, const char *text, int text_size)
{
	/*  */
	fprintf(stderr, "Sorry. Not implemented.\n");
	return -1;
}

/*
	eLXgx^C[Wɕϊ
*/
int text2raw(unsigned char *raw, int baud, const char *file, const char *text, int text_size)
{
	if(baud == 300)
		return text2raw_300(raw, file, text, text_size);
	else if(baud == 1200)
		return text2raw_1200(raw, file, text, text_size);
	else
		return -1;
}

/*
	1ubNoCi300baud̉t@Cɕϊ, ̃ubNֈړ ()
*/
static int bin2wave_300_block_next(const char *out_path, const char *file, int kind, int *asc_block, int *bin_block, int *address, const unsigned char **bin, int *bin_size)
{
	int baud = 300, result, raw_size, wave_size;
	unsigned char raw[512], *p_raw = raw, *wave;

	result = bin2raw_300_block_next(&p_raw, file, kind, asc_block, bin_block, address, bin, bin_size);
	raw_size = (int )(p_raw - raw);

	wave = malloc(getWaveSize(baud, raw_size));
	wave_size = putWaveSilent(wave, 1);
	if(appendWave(out_path, wave, wave_size) < 0)
		result = -1;

	wave_size = putWaveBytes(wave, baud, raw, raw_size);
	if(appendWave(out_path, wave, wave_size) < 0)
		result = -1;

	free(wave);
	return result;
}

/*
	1ubNoCi300baud̉t@Cɕϊ ()
*/
static int bin2wave_300_block(const char *out_path, const char *file, int kind, int asc_block, int bin_block, int address, const unsigned char *bin, int bin_size)
{
	return bin2wave_300_block_next(out_path, file, kind, &asc_block, &bin_block, &address, &bin, &bin_size);
}

/*
	oCi300baud̉t@Cɕϊ (bin2wavẻ)
*/
static int bin2wave_300(const char *out_path, const char *file, int address, const unsigned char *bin, int bin_size)
{
	int asc_block = 1, bin_block = 1, result;

	while((result = bin2wave_300_block_next(out_path, file, 0x01, &asc_block, &bin_block, &address, &bin, &bin_size)) > 0)
		;
	return (result == 0 ? 1: -1);
}

/*
	oCi1200baud̉t@Cɕϊ (bin2wavẻ)
*/
static int bin2wave_1200(const char *out_path, const char *file, int address, const unsigned char *bin, int bin_size)
{
	int baud = 1200, raw_size, wave_size, result;
	unsigned char *raw, *wave;

	raw = malloc(272 + bin_size);
	raw_size = bin2raw(raw, baud, file, address, bin, bin_size);

	wave = malloc(MAX(getWaveSize(baud, raw_size), getWaveSizeSec(1)));
	wave_size = putWaveSilent(wave, 1);
	appendWave(out_path, wave, wave_size);

	wave_size = putWaveBytes(wave, baud, raw, raw_size);
	result = appendWave(out_path, wave, wave_size);

	free(wave);
	return result;
}

/*
	oCit@Cɕϊ
*/
int bin2wave(const char *out_path, int baud, const char *file, int address, const unsigned char *bin, int bin_size)
{
	if(baud == 300)
		return bin2wave_300(out_path, file, address, bin, bin_size);
	else if(baud == 1200)
		return bin2wave_1200(out_path, file, address, bin, bin_size);
	else
		return -1;
}

/*
	eLXgt@C300baud̉ɕϊ (text2wav̉)
*/
static int text2wave_300(const char *out_path, const char *file, const char *text, int text_size)
{
	int asc_block = 1, bin_size;
	unsigned char bin[0x100];

	while(text_size > 0) {
		bin_size = text2bin(bin, &text, &text_size);
		bin2wave_300_block(out_path, file, 0x10, asc_block, 1, 0x600, bin, bin_size);
		bin2wave_300_block(out_path, file, 0x00, asc_block, 1, 0x600, bin, 1);
		asc_block++;
	}

	bin[1] = bin[0] = 0xff;
	bin2wave_300_block(out_path, file, 0x10, asc_block, 1, 0x600, bin, 2);
	return bin2wave_300_block(out_path, file, 0x00, asc_block, 1, 0x600, bin, 1);
}

/*
	eLXgt@C1200baud̉ɕϊ (text2wav̉)
*/
static int text2wave_1200(const char *out_path, const char *file, const char *text, int text_size)
{
	/*  */
	fprintf(stderr, "Sorry. Not implemented.\n");
	return -1;
}

/*
	eLXgt@Cɕϊ
*/
int text2wave(const char *out_path, int baud, const char *file, const char *text, int text_size)
{
	if(baud == 300)
		return text2wave_300(out_path, file, text, text_size);
	else if(baud == 1200)
		return text2wave_1200(out_path, file, text, text_size);
	else
		return -1;
}

/*
	Copyright (c) 2010 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */
